--[[
--* PtokaX_Remote_Admin.lua - hub-side script for PRAdmin v2.13
--* Copyright (C) 2006-2009 Thor ( ejjeliorjarat [on] gmail [dot] com )
--*
--* This program is free software; you can redistribute it and/or modify
--* it under the terms of the GNU General Public License as published by
--* the Free Software Foundation; either version 2 of the License, or
--* (at your option) any later version.
--*
--* This program is distributed in the hope that it will be useful,
--* but WITHOUT ANY WARRANTY; without even the implied warranty of
--* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
--* GNU General Public License for more details.
--*
--* You should have received a copy of the GNU General Public License
--* along with this program; if not, write to the Free Software
--* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
--*]]

-- S E T T I N G S --

-- For which tab has the user rights to access?
-- [1] = Settings [2] = Bans [3] = Scripts [4] = Profiles [5] = Regs [6] = Textfiles
tAllowedProfiles = {
["Master"] = {
	[1] = 1,
	[2] = 1,
	[3] = 1,
	[4] = 1,
	[5] = 1,
	[6] = 1,},
["Operator"] = {
	[1] = 1,
	[2] = 0,
	[3] = 0,
	[4] = 0,
	[5] = 0,
	[6] = 1,},
}
-- Set this to true to fix the wrong-encoded messages
bCorrect = true
-- Set this to true to make invisible the client in the userlist else to false or nil
bRemove = true

-- Ok, don't modify below :)
if os.getenv("windir") then
	require "pxlfs"
else
	require "lfs"
end

assert(IP2Country,"You can't run this script PtokaX 0.4.1.0 and before version. Please download "..
"the latest version from the official site: http://PtokaX.org")

-- Equivalent to C's "cond ? a : b", all terms will be evaluated
function iff(cond,a,b) return cond and a or b end

tPra = {}

function OpConnected(tUser)
	if bRemove then
		for i=1,#tPra do
			Core.SendToUser(tUser,"$Quit "..tPra[i].."|")
		end
		if (Core.GetUserValue(tUser,6) == "PRA" and Core.GetUserValue(tUser,11)) then
			table.insert(tPra,tUser.sNick)
		end
	end
end

UserConnected = OpConnected
RegConnected = OpConnected

function OpDisconnected(tUser)
	if bRemove then
		if (Core.GetUserValue(tUser,6) == "PRA") then
			for i=1,#tPra do
				if tPra[i] == tUser.sNick then
					table.remove(tPra,i)
					break
				end
			end
		end
	end
end

function Allowed(curUser,i)
	return (ProfMan.GetProfile(curUser.iProfile) and tAllowedProfiles[ProfMan.GetProfile(curUser.iProfile).sProfileName][i] == 1)
end

function UnknownArrival(curUser,data)
	data = data:sub(1,-2)
	local tTable = {
	["$GET"] = function()
		local sType = data:match("^$GET%s(%d)")
		if sType == "0" then
			if not Allowed(curUser,1) then
                Send(curUser,"$ERR 99")
			else
			    local tSet = {}
				-- Booleans
				for i=0,55 do
					table.insert(tSet,iff(SetMan.GetBool(i),"1","0"))
				end
                Send(curUser,"$SET 1 "..table.concat(tSet,"$$").."$$")
			end
		elseif sType == "1" then
		    if not Allowed(curUser,1) then
                Send(curUser,"$ERR 99")
			else
			    local tSet = {}
				-- Numbers
				for i=0,113 do
					table.insert(tSet,tostring(SetMan.GetNumber(i)))
				end
				Send(curUser,"$SET 2 "..table.concat(tSet,"$$").."$$")
			end
		elseif sType == "2" then
		    if not Allowed(curUser,1) then
                Send(curUser,"$ERR 99")
			else
			    local tSet = {}
			    for langfile in lfs.dir(Core.GetPtokaXPath().."/language") do
			    	if langfile ~= "." and langfile ~= ".." then
			    		table.insert(tSet,langfile:sub(1,-5))
					end
				end
				if next(tSet) then
	    			Send(curUser,"$SET 3 lang "..table.concat(tSet,"$$").."$$")
				end
				tSet = {}
				-- Strings
				for i=0,34 do
					table.insert(tSet,tostring(SetMan.GetString(i)))
				end
	   			Send(curUser,"$SET 3 "..table.concat(tSet,"$$").."$$")
				-- MOTD
				Send(curUser,"$SET 3 motd "..(SetMan.GetMOTD() or ""))
			end
		elseif sType == "3" then
		    if not Allowed(curUser,2) then
                Send(curUser,"$ERR 99")
			else
	            -- Bans
	            local subtype = data:match("^%$GET%s3%s([01])$")
	            if subtype then
	                if subtype == "0" then
			            local tSet = {}
						for k,v in ipairs(BanMan.GetPermBans()) do
							table.insert(tSet,(v.sIP or "<Nick ban>").."$"..(v.sNick or "<IP ban>").."$"..iff(v.bFullIpBan,1,0).."$"..(v.sBy or "N/A").."$"..(v.sReason or "N/A"))
						end
	     				Send(curUser,"$SET 4 1 "..table.concat(tSet,"$$").."$$")
						tSet = {}
						for k,v in ipairs(BanMan.GetTempBans()) do
							table.insert(tSet,(v.sIP or "<Nick ban>").."$"..(v.sNick or "<IP ban>").."$"..iff(v.bFullIpBan,1,0).."$"..(v.sBy or "N/A").."$"..(v.sReason or "N/A").."$"..v.iExpireTime)
						end
	     				Send(curUser,"$SET 4 2 "..table.concat(tSet,"$$").."$$")
					else
					    local tSet = {}
						for k,v in ipairs(BanMan.GetPermRangeBans()) do
							table.insert(tSet,v.sIPFrom.."$"..v.sIPTo.."$"..iff(v.bFullIpBan,1,0).."$"..(v.sBy or "N/A").."$"..(v.sReason or "N/A"))
						end
	     				Send(curUser,"$SET 4 3 "..table.concat(tSet,"$$").."$$")
						tSet = {}
						for k,v in ipairs(BanMan.GetTempRangeBans()) do
							table.insert(tSet,v.sIPFrom.."$"..v.sIPTo.."$"..iff(v.bFullIpBan,1,0).."$"..(v.sBy or "N/A").."$"..(v.sReason or "N/A").."$"..v.iExpireTime)
						end
	    				Send(curUser,"$SET 4 4 "..table.concat(tSet,"$$").."$$")
					end
				else
					local tSet = {}
					for k,v in ipairs(BanMan.GetPermBans()) do
						table.insert(tSet,(v.sIP or "<Nick ban>").."$"..(v.sNick or "<IP ban>").."$"..iff(v.bFullIpBan,1,0).."$"..(v.sBy or "N/A").."$"..(v.sReason or "N/A"))
					end
	    			Send(curUser,"$SET 4 1 "..table.concat(tSet,"$$").."$$")
					tSet = {}
					for k,v in ipairs(BanMan.GetTempBans()) do
						table.insert(tSet,(v.sIP or "<Nick ban>").."$"..(v.sNick or "<IP ban>").."$"..iff(v.bFullIpBan,1,0).."$"..(v.sBy or "N/A").."$"..(v.sReason or "N/A").."$"..v.iExpireTime)
					end
	    			Send(curUser,"$SET 4 2 "..table.concat(tSet,"$$").."$$")
					tSet = {}
					for k,v in ipairs(BanMan.GetPermRangeBans()) do
						table.insert(tSet,v.sIPFrom.."$"..v.sIPTo.."$"..iff(v.bFullIpBan,1,0).."$"..(v.sBy or "N/A").."$"..(v.sReason or "N/A"))
					end
	    			Send(curUser,"$SET 4 3 "..table.concat(tSet,"$$").."$$")
					tSet = {}
					for k,v in ipairs(BanMan.GetTempRangeBans()) do
						table.insert(tSet,v.sIPFrom.."$"..v.sIPTo.."$"..iff(v.bFullIpBan,1,0).."$"..(v.sBy or "N/A").."$"..(v.sReason or "N/A").."$"..v.iExpireTime)
					end
	    			Send(curUser,"$SET 4 4 "..table.concat(tSet,"$$").."$$")
				end
			end
		elseif sType == "4" then
		    if not Allowed(curUser,3) then
                Send(curUser,"$ERR 99")
			else
			    -- Scripts
				ScriptMan.Refresh()
			    local tSet = {}
				for _,script in ipairs(ScriptMan.GetScripts()) do
					table.insert(tSet,script.sName.."$"..iff(script.bEnabled,"1","0").."$"..(script.iMemUsage or "0"))
				end
				Send(curUser,"$SET 5 "..table.concat(tSet,"$$").."$$")
			end
		elseif sType == "5" then
		    -- Profiles
			if Allowed(curUser,5) then
		        local tSet = {}
				for i,v in ipairs(ProfMan.GetProfiles()) do
					local sPermissions = ""
					if Allowed(curUser,4) then
						for j=0,55 do
							sPermissions = sPermissions..iff(ProfMan.GetProfilePermission(v.iProfileNumber, j),"1","0")
						end
					end
					if sPermissions == "" then sPermissions = string.rep("0",55) end
					table.insert(tSet,v.iProfileNumber.."$"..v.sProfileName.."$"..sPermissions)
				end
		   		Send(curUser,"$SET 6 "..table.concat(tSet,"$$").."$$")
			end
		elseif sType == "6" then
		    if not Allowed(curUser,5) then
                Send(curUser,"$ERR 99")
			else
			    local tSet = {}
				-- Registered users
				for i,v in ipairs(RegMan.GetRegs()) do
					if ((curUser.iProfile == 0) or (v.iProfile > curUser.iProfile)) then
						local nick = v.sNick:gsub(string.char(10),""):gsub(string.char(13),"")
						local pass = v.sPassword:gsub(string.char(10),""):gsub(string.char(13),"")
						table.insert(tSet,nick.."$"..pass.."$"..v.iProfile)
					end
				end
	   			Send(curUser,"$SET 7 "..table.concat(tSet,"$$").."$$")
			end
		elseif sType == "7" then
		    if not Allowed(curUser,6) then
                Send(curUser,"$ERR 99")
			else
			    local tSet = {}
	            for textfile in lfs.dir(Core.GetPtokaXPath().."/texts") do
			    	if textfile ~= "." and textfile ~= ".." and textfile:lower():sub(-4) == ".txt"then
			    		table.insert(tSet,textfile:sub(1,-5))
					end
				end
				if next(tSet) then
	      			Send(curUser,"$SET 8 "..table.concat(tSet,"$$").."$$")
				end
			end
			if bRemove then
				Core.SendToAll("$Quit "..curUser.sNick.."|")
			end
		elseif sType == "8" then
			-- Files
			local file = data:match("^%$GET%s8%s\"(%S+)\"$")
			if file:lower():sub(-4) == ".lua" then
				if not Allowed(curUser,3) then
					Send(curUser,"$ERR 99")
	            else
					local f = io.open(Core.GetPtokaXPath().."scripts/"..file,"r")
					if f then
						local c = f:read("*a")
						Send(curUser,"$FILE \""..file.."\" "..c)
	                    f:close()
					else
						Send(curUser,"$ERR 1")
					end
				end
			else
				if not Allowed(curUser,6) then
					Send(curUser,"$ERR 99")
				else
					local f = io.open(Core.GetPtokaXPath().."texts/"..file,"r")
					if f then
						local c = f:read("*a")
						Send(curUser,"$FILE \""..file.."\" "..c)
	                    f:close()
					else
						Send(curUser,"$ERR 1")
					end
				end
			end
		end
	end,
	["$SET"] = function()
		local sType = data:match("^%$SET%s(%d)")
		if sType == "0" then
		    if not Allowed(curUser,1) then
				Send(curUser,"$ERR 99")
				return
			end
			for id,value in data:sub(8):gmatch("(%d+)%$(%d)%$%$") do
				SetMan.SetBool(tonumber(id),iff(value=="1",true,false))
			end
			SetMan.Save()
		elseif sType == "1" then
		    if not Allowed(curUser,1) then
				Send(curUser,"$ERR 99")
				return
			end
			for id,value in data:sub(8):gmatch("(%d+)%$(%d+)%$%$") do
				SetMan.SetNumber(tonumber(id),tonumber(value))
			end
			SetMan.Save()
		elseif sType == "2" then
		    if not Allowed(curUser,1) then
				Send(curUser,"$ERR 99")
				return
			end
			if data:find("^%$SET%s2%smotd") then
				local motd = data:match("^%$SET%s2%smotd%s(.*)")
				SetMan.SetMOTD(motd)
				return
			end
			for id,value in data:sub(8):gmatch("(%d+)%$(.-)%$%$") do
				if (id == "25" or id == "26") then
					SetMan.SetBool(19,false)
					SetMan.SetString(tonumber(id),value)
					SetMan.SetBool(19,true)
				else
					SetMan.SetString(tonumber(id),value)
				end
			end
			SetMan.Save()
		elseif sType == "3" then
		    if not Allowed(curUser,2) then
				Send(curUser,"$ERR 99")
				return
			end
		    local subtype = data:match("^%$SET%s3%s([0-7])")
			-- 0 - Unban; 1 - Clear tempbans; 2 - Clear permbans; 3 - Rangeunban
			-- 4 - Clear rangetempbans; 5 - Clear rangepermbans; 6 - Ban; 7 - Rangeban
		    if subtype == "0" then
		        local item,sIPorsNick,sIP = data:match("^%$SET%s3%s0%s(%d+)%s(%S+)%s*(%S*)")
		        if BanMan.Unban(sIPorsNick) then
					if sIP ~= "" then BanMan.Unban(sIP) end
		            BanMan.Save()
					Send(curUser,"$CONF 10 0 "..item)
				else
				    Send(curUser,"$ERR 10 0")
				end
			elseif subtype == "1" then
			    BanMan.ClearTempBans()
			    BanMan.Save()
			    Send(curUser,"$CONF 10 2")
			elseif subtype == "2" then
			    BanMan.ClearPermBans()
			    BanMan.Save()
			    Send(curUser,"$CONF 10 3")
			elseif subtype == "3" then
			    local item,sIPFrom,sIPTo = data:match("^%$SET%s3%s3%s(%d+)%s(%S+)%s%-%s(%S+)$")
			    if item then
			        if BanMan.RangeUnban(sIPFrom,sIPTo) then
			            BanMan.Save()
			            Send(curUser,"$CONF 10 1 "..item)
			        else
			            Send(curUser,"$ERR 10 1")
			        end
				end
			elseif subtype == "4" then
				BanMan.ClearRangeTempBans()
				BanMan.Save()
				Send(curUser,"$CONF 10 4")
			elseif subtype == "5" then
				BanMan.ClearRangePermBans()
				BanMan.Save()
				Send(curUser,"$CONF 10 5")
			elseif subtype == "6" then
				local this = data:match("%$SET%s3%s6%s(.+)$")
				assert(loadstring(this))()
				if t[8] > 0 then
					local nTime = math.floor((t[8]-os.time())/60)
					if t[1] == true then BanMan.TempBanIP(t[4],nTime,t[6],t[7],t[2]) end
					if t[3] == true then BanMan.TempBanNick(t[5],nTime,t[6],t[7]) end
					Send(curUser,"$SET 4 2 "..iff(t[4]=="","<Nick ban>",t[4]).."$"..iff(t[5]==" ","<IP ban>",t[5]).."$"..
					iff(t[2]==true,"1","0").."$"..t[7].."$"..t[6].."$"..t[8].."$$")
				else
					if t[1] == true then BanMan.BanIP(t[4],t[6],t[7],t[2]) end
					if t[3] == true then BanMan.BanNick(t[5],t[6],t[7]) end
					Send(curUser,"$SET 4 1 "..iff(t[4]=="","<Nick ban>",t[4]).."$"..iff(t[5]=="","<IP ban>",t[5])..
					"$"..iff(t[2]==true,"1","0").."$"..t[7].."$"..t[6].."$$")
				end
			elseif subtype == "7" then
				local this = data:match("%$SET%s3%s7%s(.+)$")
				assert(loadstring(this))()
				if t[6] > 0 then
					local nTime = math.floor((t[6]-os.time())/60)
					BanMan.RangeTempBan(t[1],t[2],nTime,t[4],t[5],t[3])
					Send(curUser,"$SET 4 4 "..t[1].."$"..t[2].."$"..iff(t[3]==true,"1","0").."$"..t[5].."$"..t[4].."$"..t[6].."$$")
				else
					BanMan.RangeBan(t[1],t[2],t[4],t[5],t[3])
					Send(curUser,"$SET 4 3 "..t[1].."$"..t[2].."$"..iff(t[3]==true,"1","0").."$"..t[5].."$"..t[4].."$$")
				end
			end
		elseif sType == "4" then
		    if not Allowed(curUser,3) then
		        Send(curUser,"$ERR 99")
				return
			end
		    local stat,script = data:match("^%$SET%s4%s(%S+)%s\"(.+)\"$")
		    -- Scripts. stat: 0/1 moves down/up, true/false starts/stops the given script
		    if script then
				if stat == "true" then
					if ScriptMan.StartScript(script) then
						Send(curUser,"$CONF 4 "..script)
					else
						Send(curUser,"$ERR 4 "..script)
					end
				elseif stat == "false" then
					if script == "Ptokax_Remote_Admin.lua" then
						if (curUser.iProfile == 0) then
							ScriptMan.StopScript(script)
							Send(curUser,"$CONF 4 "..script)
						else
							Send(curUser,"$ERR 99")
						end
						return true
					end
					if ScriptMan.StopScript(script) then
						Send(curUser,"$CONF 4 "..script)
					else
						Send(curUser,"$ERR 4 "..script)
					end
				elseif stat == "0" then
		            if ScriptMan.MoveDown(script) then
						Send(curUser,"$CONF 2 "..script)
					else
						Send(curUser,"$ERR 2")
					end
				elseif stat == "1" then
				    if ScriptMan.MoveUp(script) then
						Send(curUser,"$CONF 3 "..script)
					else
						Send(curUser,"$ERR 3")
					end
				end
			end
		elseif sType == "5" then
		    if not Allowed(curUser,4) then
				Send(curUser,"$ERR 99")
				return
			end
		    local profile,todo = data:match("^%$SET%s5%s(%S+)%s(%S+)")
		    -- Profiles. todo: 0/1 moves down/up, true/false adds/deletes the given profile
		    -- if todo = p then it'll set up the given permission id to the given value
		    if todo == "0" then
				if ((curUser.iProfile == 0) or (tonumber(profile) > curUser.iProfile)) then
		            if ProfMan.MoveDown(tonumber(profile)) then
						Send(curUser,"$CONF 6 "..profile)
					else
						Send(curUser,"$ERR 6")
					end
				else
					Send(curUser,"$ERR 99")
				end
			elseif todo == "1" then
				if ((curUser.iProfile == 0) or (tonumber(profile) > curUser.iProfile)) then
				    if ProfMan.MoveUp(tonumber(profile)) then
						Send(curUser,"$CONF 7 "..profile)
					else
						Send(curUser,"$ERR 7")
					end
				else
					Send(curUser,"$ERR 99")
				end
            elseif todo == "true" then
                if ProfMan.AddProfile(profile) then
			    	Send(curUser,"$CONF 8 "..profile)
				else
				    Send(curUser,"$ERR 8")
				end
			elseif todo == "false" then
			    if ProfMan.RemoveProfile(profile) then
			        Send(curUser,"$CONF 9 "..profile)
				else
				    Send(curUser,"$ERR 9")
				end
			elseif todo == "p" then -- permission
				local profile,ID,value = data:match("^%$SET%s5%s(%d+)%sp%s(%d+)%s([01])$")
			    if profile then
					if ((curUser.iProfile == 0) or (tonumber(profile) > curUser.iProfile)) then
				        if ID == "56" then -- Check/uncheck all
				            for i=0,55 do
				                if ProfMan.SetProfilePermission(tonumber(profile),i,iff(value == "1",true,false)) then
									Send(curUser,"$CONF 11 "..i.." "..value)
								else
								    Send(curUser,"$ERR 11")
								end
							end
						else
					        if ProfMan.SetProfilePermission(tonumber(profile),tonumber(ID),iff(value == "1",true,false)) then
					            Send(curUser,"$CONF 11 "..ID.." "..value)
							else
							    Send(curUser,"$ERR 11 "..ID)
							end
						end
					else
						Send(curUser,"$ERR 99")
					end
			    end
			end
		elseif sType == "6" then
		    if not Allowed(curUser,5) then
				Send(curUser,"$ERR 99")
				return
			end
		    -- regs
		    local subtype = data:match("^%$SET%s6%s(%d)")
		    -- subtype: 0 - del; 1 - add; 2 - mod registered user
		    if subtype == "0" then
		        local nick = data:match("^%$SET%s6%s0%s(%S+)$")
		        if nick then
					if ((curUser.iProfile == 0) or (RegMan.GetReg(nick) and (RegMan.GetReg(nick).iProfile > curUser.iProfile))) then
						if RegMan.DelReg(nick) then
							Send(curUser,"$CONF 12 "..nick)
						else
							Send(curUser,"$ERR 12 "..nick)
						end
					else
						Send(curUser,"$ERR 99")
					end
				end
			elseif subtype == "1" then
			    local nick,pass,profile = data:match("^%$SET%s6%s1%s(%S+)%s(%S+)%s(%d+)$")
			    if nick then
					if ((curUser.iProfile == 0) or (tonumber(profile) > curUser.iProfile)) then
				        if RegMan.AddReg(nick,pass,tonumber(profile)) then
				            Send(curUser,"$CONF 13 "..nick.." "..pass.." "..profile)
						else
						    Send(curUser,"$ERR 13 "..nick)
						end
					else
						Send(curUser,"$ERR 99")
					end
				end
			elseif subtype == "2" then
			    local nick,pass,profile = data:match("^%$SET%s6%s2%s(%S+)%s(%S+)%s(%d+)$")
			    if nick then
					if ((curUser.iProfile == 0) or (tonumber(profile) > curUser.iProfile)) then
						if RegMan.ChangeReg(nick,pass,tonumber(profile)) then
							Send(curUser,"$CONF 14 "..nick.." "..pass.." "..profile)
						else
							Send(curUser,"$ERR 14 "..nick)
						end
					else
						Send(curUser,"$ERR 99")
					end
				end
			end
		elseif sType == "7" then
		    local file,contents = data:match("^%$SET%s7%s\"(.-)\"%s(.*)")
		    if file:lower():sub(-4) == ".lua" then
				if not Allowed(curUser,3) then
					Send(curUser,"$ERR 99")
					return
				else
					if file == "Ptokax_Remote_Admin.lua" and curUser.iProfile ~= 0 then
						Send(curUser,"$ERR 99")
						return true
					end
					local f = io.open(Core.GetPtokaXPath().."/scripts/"..file,"w+")
					if f then
						if contents == "del" then
	                        f:close()
	                        ScriptMan.StopScript(file) -- Nevermind if it doesn't run
							os.remove(Core.GetPtokaXPath().."/scripts/"..file)
						else
							f:write(contents)
	                        f:close()
						end
						ScriptMan.Refresh()
					else
						Send(curUser,"$ERR 1")
					end
				end
			else
				if not Allowed(curUser,6) then
					Send(curUser,"$ERR 99")
					return
				else
				    local f = io.open(Core.GetPtokaXPath().."/texts/"..file,"w+")
					if f then
						if contents == "del" then
							f:close()
	                        os.remove(Core.GetPtokaXPath().."/texts/"..file)
						else
							f:write(contents)
	                        f:close()
						end
					else
						Send(curUser,"$ERR 1")
					end
				end
			end
		end
	end,
	["$RSS"] = function()
	    if not ProfMan.GetProfile(curUser.iProfile).tProfilePermissions.bRestartScripts then
			Send(curUser,"$ERR 99")
			return
		end
		local script = data:match("^%$RSS%s(.+)$")
		if script then
			if ScriptMan.RestartScript(script) then
				Send(curUser,"$CONF 5 "..script)
			else
				Send(curUser,"$ERR 5")
			end
		else
			ScriptMan.Restart()
		end
	end,
	}
	data = Escape(data)
	local cmd = data:match("^(%$%w+)")
	if tTable[cmd] then
		if not tAllowedProfiles[ProfMan.GetProfile(curUser.iProfile).sProfileName] then
		    Core.SendToUser(curUser,"<"..SetMan.GetString(21).."> You don't have permission to get/set the settings, be careful what are you doing, your IP has been reported to OPs!|")
			Core.SendToOpChat("An unallowed user, "..curUser.sNick.." (IP: "..curUser.sIP..") wanted to get/set the hub's settings, he has been disconnected.")
		else
			data = data:gsub("%[endpipe%]","|")
			tTable[cmd]()
			return true -- Don't disconnect the user
		end
	end
end

function Escape(sText) -- luasocket has encoding problem on Unix with chars > 127
	local tEscape = {
	["€"] = "", ["‑"] = "", ["„"] = "", ["…"] = "", [" "] = "", ["‡"] = "", ["‰"] = "", [" "] = "",
	["‹"] = "", ["ő"] = "", ["Ť"] = "", ["Ž"] = "", ["Ź"] = "", ["‘"] = "", ["’"] = "", ["“"] = "",
	["”"] = "", ["•"] = "", ["–"] = "", ["—"] = "", ["™"] = "", ["š"] = "", ["›"] = "", ["ś"] = "",
	["ť"] = "", ["ž"] = "", ["ź"] = "", ["ˇ"] = "", ["˘"] = "", ["Ł"] = "", ["Ą"] = "", ["Ş"] = "", ["Ż"] = "",
	["˛"] = "", ["ł"] = "", ["ą"] = "", ["ş"] = "", ["Ľ"] = "", ["˝"] = "", ["ľ"] = "", ["ż"] = "", ["Ŕ"] = "",
	["Á"] = "", ["Â"] = "", ["Ă"] = "", ["Ä"] = "", ["Ĺ"] = "", ["Ć"] = "", ["Ç"] = "", ["Č"] = "", ["É"] = "",
	["Ę"] = "", ["Ë"] = "", ["đ"] = "", ["Í"] = "", ["Î"] = "", ["Ď"] = "", ["Đ"] = "", ["Ń"] = "", ["Ň"] = "",
	["Ó"] = "", ["Ô"] = "", ["Ő"] = "", ["Ö"] = "", ["×"] = "", ["Ř"] = "", ["Ů"] = "", ["Ñ"] = "", ["Ű"] = "",
	["Ü"] = "", ["Ý"] = "", ["Ţ"] = "", ["ß"] = "", ["ŕ"] = "", ["á"] = "", ["â"] = "", ["ă"] = "", ["ä"] = "",
	["ĺ"] = "", ["ć"] = "", ["ç"] = "", ["č"] = "", ["é"] = "", ["ę"] = "", ["ë"] = "", ["ě"] = "", ["í"] = "",
	["î"] = "", ["ď"] = "", ["đ"] = "", ["ń"] = "", ["ň"] = "", ["ó"] = "", ["ô"] = "", ["ő"] = "", ["ö"] = "",
	["÷"] = "", ["ř"] = "", ["ů"] = "", ["ú"] = "", ["ű"] = "", ["ü"] = "", ["ý"] = "", ["ţ"] = "", ["˙"] = ""
	}
	for k,v in pairs(tEscape) do
		sText = sText:gsub(k,v)
	end
	sText = sText:gsub("(.)","%1")
	return sText
end

function Send(curUser,sMessage)
	sMessage = sMessage:gsub("|","[endpipe]")
	Core.SendToUser(curUser,sMessage.."|")
end
